#include <Servo.h>            // include the standard servo library

Servo leftRightServo;         // set a variable to map the servo
Servo VitesseServo;
int vitesse;
int angle;
int val;
int MavantMax;
int MarriereMax;
int GaucheMax;
int DroiteMax;
int octetReception=0; // variable de stockage des valeurs reçues sur le port Série (ASCII)
char caractereRecu=0; // variable pour stockage caractère recu
int compt=0; // variable comptage caractères reçus
String chaineReception=""; // déclare un objet String vide pour reception chaine
String commande = "";


void setup()   { // debut de la fonction setup()
  VitesseServo.attach(11);
  leftRightServo.attach(10);
  MavantMax = 70;
  MarriereMax = 145;
  GaucheMax = 50;
  DroiteMax = 140;
  vitesse = 100;
  angle = 100;
  Serial.begin(9600);
  VitesseServo.write(vitesse);
  leftRightServo.write(angle);
} // fin de la fonction setup()

void loop(){ // debut de la fonction loop()
while (Serial.available()>0) { // tant qu'un octet en réception
        octetReception=Serial.read(); // Lit le 1er octet reçu et le met dans la variable
        compt=compt+1;
        Serial.println("Ascii Caractere "+ String(compt) +" = "+ String(octetReception)); // affiche code ASCII Octet reçu
        if (octetReception==42) { // si Octet reçu est le saut de ligne
          Serial.println("Saut de ligne recu");
          Serial.println ("Chaine recue="+chaineReception); // affiche la chaine recue
          commande = chaineReception;
          chaineReception=""; //RAZ le String de réception
          compt=0; // RAZ compteur
          delay(100); // pause
          break; // sort de la boucle while
        }
        else { // si le caractère reçu n'est pas un saut de ligne
           caractereRecu=char(octetReception); // convertit l'octet reçu en caractère
           chaineReception=chaineReception+caractereRecu; // ajoute le caratère au String
        }

} // fin tant que  octet réception

if (commande != ""){
Serial.println(commande[0]);
Serial.println(int(commande[0]));
//commande = "";
}

if (int(commande[0]) == 118){
  Serial.println(int(commande[1]));
  Serial.println(int(commande[2]));
  Serial.println(int(commande[3]));
  vitesse = 100*(commande[1]-48)+10*(commande[2]-48)+(commande[3]-48);
  Serial.println(vitesse);
  VitesseServo.write(vitesse);
  commande = "";
}
if (int(commande[0]) == 97){
  Serial.println(int(commande[1]));
  Serial.println(int(commande[2]));
  Serial.println(int(commande[3]));
  angle = 100*(commande[1]-48)+10*(commande[2]-48)+(commande[3]-48);
  Serial.println(angle);
  leftRightServo.write(angle);
  commande = "";
}

} // fin de la fonction loop() - le programme recommence au début de la fonction loop sans fin

